# Magento2 API Wrapper
[![License: MIT](https://img.shields.io/npm/l/magento2-api-wrapper)](LICENSE)
[![NPM](https://img.shields.io/npm/v/magento2-api-wrapper)](https://www.npmjs.com/package/magento2-api-wrapper)
[![Dependencies](https://img.shields.io/librariesio/release/npm/magento2-api-wrapper)](#)
[![Builds](https://gitlab.com/lumnn/magento2-api-wrapper/badges/master/pipeline.svg)](#)
[![Coverage](https://gitlab.com/lumnn/magento2-api-wrapper/badges/master/coverage.svg)](#)

> A basic wrapper for Magento 2 API

_Currently only works in Node environment. But, it should be easy to make it
compatible in browsers. Feel free to submit a merge request or contact me._

## Install

```sh
npm install magento2-api-wrapper
```

## Usage

```js
const Magento2Api = require('magento2-api-wrapper')

var consumer = new Magento2Api({ api: { url: 'https://localhost' }})

consumer.get('directory/countries')
  .then(data => console.log)

// Api Keys: Magento Admin > System > Extensions > Integration
var admin = new Magento2Api({ api: {
  url: 'https://localhost',
  consumerKey: 'xxx',
  consumerSecret: 'xxx',
  accessToken: 'xxx',
  tokenSecret: 'xxx',
}})

admin.get('products', {
  params: {
    searchCriteria: {
      currentPage: 1,
      pageSize: 1,
    }
  }
})
  .then(data => console.log)
```

**Responses:** Successfull response returns data as in Magento - not wrapped as in Axios.

## Methods / Properties

It provides all same methods as Axios: https://github.com/axios/axios#request-method-aliases
(request, get, delete, head, options, post, put, patch)

- **.axios** - get axios instance
- **.baseUrl** - get base url

## Run tests

```sh
npm run test
```
